
import path, { basename } from 'node:path'
import jsdom from 'jsdom'

export async function render (appPath) {
  const { JSDOM } = jsdom
  const dom = new JSDOM();
  global.window = dom.window
  global.document = window.document
  global.navigator = window.navigator
  global.history = window.history
  global.location = window.location
  window.nodeis = true
  let routes = []
  try {

    const a = await import(/* @vite-ignore */path.resolve(appPath, './main'))
    if (!a.default.router) {
      throw new Error('路由读取失败,未在main入口导出router！')

    }
    let routeVue = a.default.router.getRoutes()
    routeVue = JSON.parse(JSON.stringify(routeVue))
    function addR (arr) {
      arr.forEach(i => {
        routes.push(i.path)
        if (i.children && i.children.length > 0) {
          addR(i.children)
        }
      });
    }
    addR(routeVue)
    delete global.document
    delete global.navigator
    delete global.history
    delete global.location
    delete global.window
    return Promise.resolve(routes)
  } catch (error) {
    throw new Error(error)
  }

}